/*
 * main program decleration
 */

#include <stdio.h>
#include <sys/types.h>    /* /usr/include/sys/types.h   */
#include <sys/stat.h>     /* /usr/include/sys/stat.h    */
#include <fcntl.h>        /* /usr/include/sys/fcntl.h   */

#define NONE       01
#define HTML       02
#define BODY       04
#define PRE       010
#define P         020
#define TITLE     040
#define CENTER   0100
#define A        0200
#define H1       0400
#define H2      01000
#define H3      02000
#define H4      04000
#define UL      010000
#define LI      020000
#define OL      040000
#define IMG    0100000
#define HR     0200000
#define BR     0400000
#define FORM   0100000
#define SELECT 0200000
#define OPTION 0400000
#define CMNT  01000000
#define B     02000000
#define TD    04000000
#define TR   010000000
#define TH   020000000
#define TABLE        040000000
#define CAPTION     0100000000
#define EM          0200000000
#define I           0400000000
#define BLOCKQUOTE 01000000000
#define FONT       02000000000
#define HEAD       04000000000

char *malloc(int size);

#define ARGC 38

void syntax();
int cmp(char *buf, char *string, int len);

int href = 0;
int lnk_sline = 1, lnk_scolumn = 0;
int url_sline = 1, url_scolumn = 0;
int pre_sline = 1, pre_scolumn = 0;
int sline = 1, scolumn = 0;
int line = 1, column = 0;
int bcnt = -1;
char *buf;
struct stat file_stats;

int fd;
int end = 0;
int state;

main(argc, argv)
	int             argc;
	char           *argv[];
{
int ch;
int inbracket = 0;
char *p;

char *fgc_clr = argv[2];
char *bgc_clr = argv[3];
char *link_clr = argv[4];
char *url_clr = argv[5];
char *html_clr = argv[6];
char *body_clr = argv[7];
char *pre_clr = argv[8];
char *title_clr = argv[9];
char *center_clr = argv[10];
char *a_clr = argv[11];
char *h1_clr = argv[12];
char *h2_clr = argv[13];
char *h3_clr = argv[14];
char *h4_clr = argv[15];
char *ul_clr = argv[16];
char *li_clr = argv[17];
char *ol_clr = argv[18];
char *img_clr = argv[19];
char *hr_clr = argv[20];
char *br_clr = argv[21];
char *form_clr = argv[22];
char *select_clr = argv[23];
char *option_clr = argv[24];
char *cmnt_clr = argv[25];
char *b_clr = argv[26];
char *td_clr = argv[27];
char *tr_clr = argv[28];
char *th_clr = argv[29];
char *table_clr = argv[30];
char *caption_clr = argv[31];
char *em_clr = argv[32];
char *i_clr = argv[33];
char *blockquote_clr = argv[34];
char *p_clr = argv[35];
char *font_clr = argv[36];
char *head_clr = argv[37];


if (argc != ARGC){

    fprintf(stderr, "html.p: color pragma syntax error(%d parameters used, %d expected), defaults used.\n", argc, ARGC);

    html_clr = body_clr =  p_clr = title_clr = center_clr = a_clr = h1_clr = h2_clr = h3_clr = 
    h4_clr = ul_clr = ol_clr = img_clr = hr_clr =  br_clr = form_clr = select_clr = option_clr = 
    b_clr = td_clr = tr_clr = th_clr = table_clr = caption_clr = em_clr = i_clr =  
    blockquote_clr = font_clr = head_clr = "cyan";

    cmnt_clr = li_clr = pre_clr = "white";
    fgc_clr = "yellow";
    bgc_clr = "black";
    link_clr = "green";
    url_clr = "red";
}

stat(argv[1], &file_stats);
buf = malloc(file_stats.st_size + 10);

end = 0; /* needed for what I think is a compiler bug */
fd = open(argv[1], 0);
read(fd, buf, file_stats.st_size);

fprintf(stdout, "1,$ ca;fgc '#ffff0010ffff';bgc %s; fgc %s\n",  bgc_clr, fgc_clr);

while (bcnt++ <= file_stats.st_size){

    ch = buf[bcnt];

    if (ch == '\n'){
        line++;
        column = 0;
        continue;
    }

    column++;

    if (state == CMNT){
         if (cmp(buf+bcnt, "-->", 3)){
           fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # B     \n", sline, scolumn, line, column+3, cmnt_clr);
           state=NONE;
         }else
           continue;
    }

    if (ch == '<'){
       inbracket++;
       continue;
    }

    if (ch == '>'){
        if (!inbracket) syntax();
           if (state == HTML  ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # HTML\n", sline, scolumn, line, column+1, html_clr);
           if (state == BODY  ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # BODY\n", sline, scolumn, line, column+1, body_clr);
           if (state == P     ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # P     \n", sline, scolumn, line, column+1, p_clr);
           if (state == FONT  ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # FONT  \n", sline, scolumn, line, column+1, font_clr);
           if (state == HEAD  ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # HEAD  \n", sline, scolumn, line, column+1, head_clr);
           if (state == TITLE ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # TITLE \n", sline, scolumn, line, column+1, title_clr);
           if (state == CENTER) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # CENTER\n", sline, scolumn, line, column+1, center_clr);
           if (state == H1    ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # H1    \n", sline, scolumn, line, column+1, h1_clr);
           if (state == H2    ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # H2    \n", sline, scolumn, line, column+1, h2_clr);
           if (state == H3    ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # H3    \n", sline, scolumn, line, column+1, h3_clr);
           if (state == H4    ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # H4    \n", sline, scolumn, line, column+1, h4_clr);
           if (state == UL    ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # UL    \n", sline, scolumn, line, column+1, ul_clr);
           if (state == LI    ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # LI    \n", sline, scolumn, line, column+1, li_clr);
           if (state == OL    ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # OL    \n", sline, scolumn, line, column+1, ol_clr);
           if (state == IMG   ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # IMG   \n", sline, scolumn, line, column+1, img_clr);
           if (state == HR    ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # HR    \n", sline, scolumn, line, column+1, hr_clr);
           if (state == BR    ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # BR    \n", sline, scolumn, line, column+1, br_clr);
           if (state == FORM  ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # FORM  \n", sline, scolumn, line, column+1, form_clr);
           if (state == SELECT) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # SELECT\n", sline, scolumn, line, column+1, select_clr);
           if (state == OPTION) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # OPTION\n", sline, scolumn, line, column+1, option_clr);
           if (state == CMNT  ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # CMNT  \n", sline, scolumn, line, column+1, cmnt_clr);
           if (state == B     ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # B     \n", sline, scolumn, line, column+1, b_clr);
           if (state == TD     ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # TD     \n", sline, scolumn, line, column+1, td_clr);
           if (state == TR     ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # TR     \n", sline, scolumn, line, column+1, tr_clr);
           if (state == TH     ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # TH     \n", sline, scolumn, line, column+1, th_clr);
           if (state == TABLE     ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # TABLE     \n", sline, scolumn, line, column+1, table_clr);
           if (state == CAPTION     ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # CAPTION     \n", sline, scolumn, line, column+1, caption_clr);
           if (state == EM     ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # EM     \n", sline, scolumn, line, column+1, em_clr);
           if (state == I     ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # I     \n", sline, scolumn, line, column+1, i_clr);
           if (state == BLOCKQUOTE     ) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # BLOCKQUOTE     \n", sline, scolumn, line, column+1, blockquote_clr);

           if ((state == PRE) && !end){
              fprintf(stdout,"[%d,%d],$ca %s %s # PRE  \n", line, column+2, pre_clr, bgc_clr);

           }

           if ((state == PRE) && end){
                  fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # PRE\n", pre_sline, pre_scolumn, line, column+1, pre_clr);
                  fprintf(stdout,"[%d,%d],$ca %s %s # PRE\n", line, column+2, fgc_clr, bgc_clr);
                  end=0;
           }

           if ((state == A) && !end){
              if (lnk_sline)
                 fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # A     \n", sline, scolumn, line, scolumn +3, a_clr);
              else
                 fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # A     \n", sline, scolumn, line, column +1, a_clr);
              url_sline = line;
              url_scolumn = column;
           }

           if ((state == A) && end){
              if (lnk_sline) fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # Link  \n", lnk_sline, lnk_scolumn+1, line, url_scolumn, link_clr);
              fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # URL  \n", url_sline, url_scolumn+1, line, column-3, url_clr);
              fprintf(stdout,"[%d,%d],[%d,%d]ca %s \"\" # url - link  \n", line, column-3, line, column+1, a_clr);
           }

           if (end) end=0;
           inbracket=0;
           state = NONE;
           continue;
    }

    if (!inbracket) continue;

    if (inbracket == 1){
       if (buf[bcnt] == '/'){
        bcnt++;
        column++;
        end = 1;
       }
       if (cmp(buf + bcnt, "html", 4))   state = HTML;
       if (cmp(buf + bcnt, "body", 4))   state = BODY;
       if (cmp(buf + bcnt, "title", 5))  state = TITLE;
       if (cmp(buf + bcnt, "center", 6)) state = CENTER;
       if (cmp(buf + bcnt, "a", 1))      state = A;
       if (cmp(buf + bcnt, "font", 4))   state = FONT;
       if (cmp(buf + bcnt, "head", 4))   state = HEAD;
       if (cmp(buf + bcnt, "h1", 2))     state = H1;
       if (cmp(buf + bcnt, "h2", 2))     state = H2;
       if (cmp(buf + bcnt, "h3", 2))     state = H3;
       if (cmp(buf + bcnt, "h4", 2))     state = H4;
       if (cmp(buf + bcnt, "ul", 2))     state = UL;
       if (cmp(buf + bcnt, "li", 2))     state = LI;
       if (cmp(buf + bcnt, "ol", 2))     state = OL;
       if (cmp(buf + bcnt, "img", 3))    state = IMG;
       if (cmp(buf + bcnt, "hr", 2))     state = HR;
       if (cmp(buf + bcnt, "br", 2))     state = BR;
       if (cmp(buf + bcnt, "td", 2))     state = TD;
       if (cmp(buf + bcnt, "tr", 2))     state = TR;
       if (cmp(buf + bcnt, "th", 2))     state = TH;
       if (cmp(buf + bcnt, "form", 4))   state = FORM;
       if (cmp(buf + bcnt, "select", 6)) state = SELECT;
       if (cmp(buf + bcnt, "!--", 3))    state = CMNT;
       if (cmp(buf + bcnt, "option", 6)) state = OPTION;
       if (cmp(buf + bcnt, "table", 5)) state = OPTION;
       if (cmp(buf + bcnt, "caption", 7)) state = OPTION;
       if (cmp(buf + bcnt, "em", 2)) state = OPTION;
       if (cmp(buf + bcnt, "blockquote", 6)) state = OPTION;

       if (cmp(buf + bcnt, "p", 1) && (buf[bcnt+1] == '>')) state = P;
       if (cmp(buf + bcnt, "b", 1) && (buf[bcnt+1] == '>')) state = B;
       if (cmp(buf + bcnt, "i", 1) && (buf[bcnt+1] == '>')) state = B;

       if (cmp(buf + bcnt, "pre", 3)){
           if (!end){
              pre_sline = line;
              pre_scolumn=column-1;
           }
           state = PRE;
       }

       scolumn=column-1 - end;
       sline=line;
    }

    if (state == A){
       p = buf + bcnt + 1;
       while ((*p == ' ') || (*p == '\t')) p++;

       if (cmp(p, "href", 4)){ 
          lnk_sline = line;
          lnk_scolumn = column +5;
       }else{
          lnk_sline = 0;
          lnk_scolumn = column-1;
       }
    }

    if (inbracket) inbracket++; 

} /* while */

fprintf(stdout, "msg 'HTML parse complete.'");

exit(0);
} /* main() */

void syntax(){
fprintf(stderr, "Syntax error at line %d, on character %d!\n", line, column);
}

int cmp(char *buf, char *string, int len){

int x, y;

while (len && (*string == (*buf | 0x20))){
       buf++;
       string++;
       len--;
}
return(!len);

}

